<img src="https://www.psdmockups.com/wp-content/uploads/2016/07/slatejs-520x292.jpg" alt="Nossas Cidades logo" title="Nossas Cidades" align="right" height="70"/>
<img src="https://avatars2.githubusercontent.com/u/1479357?v=3&s=250" alt="Nossas Cidades logo" title="Nossas Cidades" align="right" height="70"/>

# [SlateJS](https://github.com/ianstormtaylor/slate) - Embed Plugin
The goal of this plugin is to offers an easy handling of SlateJS embed mark node content editable. Providing a simple API and easy usage, basing on concept of plugin-centric by SlateJS framework.

# Usage

#### SlateJS Embed Plugin
```js
import React, { Component } from 'react'
import EmbedPlugin from 'slate-embed-plugin'

const plugins = [
  EmbedPlugin()
]

class SlateEditor extends Component {
  onChange(state) {
    this.setState({ state })
  }
  render() {
    return (
      <Editor
        plugins={plugins}
        state={this.state.state}
        onChange={this.onChange.bind(this)}
      />
    )
  }
}
```

#### SlateJS Embed Plugin Button
```js
import React, { Component } from 'react'
import { EmbedButton } from 'slate-embed-plugin'

class SlateEditor extends Component {
  onChange(state) {
    this.setState({ state })
  }
  render() {
    return (
      <div className="editor--toolbar">
        <EmbedButton
          state={this.state.state}
          onChange={this.onChange.bind(this)}
        />
      </div>
    )
  }
}
```

# Keyboard Shortcut

| Platform                 | Shortcut |
|--------------------------|----------|
| ![Apple Logo][apple]     | `⌘`+`e`  |
| ![Windows Logo][windows] | `^`+`e`  |

# API

| Target                | Description                                                                |
|-----------------------|----------------------------------------------------------------------------|
| EmbedSchema           | Schema object to configure the plugin.                                     |
| EmbedNode             | Component that holds the html that will wrap the content with embed style. |
| EmbedKeyboardShortcut | Keyboard shortcut file that manipulates `onKeyDown` event inside SlateJS.  |
| EmbedUtils            | Generic file that holds the util common functions.                         |
| EmbedButton           | Button component that have behaviour to wrap content with embed style.     |

# TODO

- Make keyboard shortcut accepts customization

[apple]: https://cdn2.iconfinder.com/data/icons/designer-skills/128/apple-ios-system-platform-os-mac-linux-48.png
[windows]: https://cdn2.iconfinder.com/data/icons/designer-skills/128/windows-48.png
